#include "camack.c"

#define ADC             10
#define ADC_RF          0
#define ADC_CF          9
#define ADC_CA          0

#define OUTPUT_REGISTER 22
#define OUTPUT_REG_F    17
#define OUTPUT_REG_A    0

#define LAM_N           4
#define LAM_F           26
#define LAM_A           0

static long loop=0,data;
static int stat;

static void dc_int_init(),dc_int_start(),dc_int_stop(),dc_int_clear();

static void dc_int_init()
{
  dc_int_start();
}

static void dc_int_start()
{
  camac_write24(0x0000f0);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,OUTPUT_REG_F);
  dc_int_clear();
  camac_NAF(LAM_N,LAM_A,LAM_F);
}

static void dc_int_stop()
{
  camac_NAF(LAM_N,LAM_A,24);
  camac_write24(0x000f00);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,OUTPUT_REG_F);
}

static void dc_int_clear()
{
  camac_NAF(ADC,ADC_CA,ADC_CF);
  camac_NAF(ADC,ADC_CA,10);
  camac_write24(0x00000f);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,OUTPUT_REG_F);
  camac_NAF(LAM_N,0,9);
}
/*
static void dc_int(int irq, struct pt_regs *regs) 
*/

static int dc_int(unsigned short buffer[])
{
  static long j; 
  void cleanup_module();

  loop++;
  j=inl(BASE_ADDRESS+4);
  if(j==0){
    printk("dc_int: interrupt %d occured, %d, LAM=%lx\n",IRQ,loop,j);
/*    if(loop>10) cleanup_module();*/
    if(dc_int_flag==0)outl(0,BASE_ADDRESS);
    else outl(8,BASE_ADDRESS);
    /* reset interrupt from crate controller*/
    return(-1);
  }
/*  printk("dc_int: interrupt %d occured, %d, LAM=%lx\n",IRQ,loop,j);*/
  buffer[0]=2;
  camac_NAF(ADC,0,ADC_RF);
  buffer[1]=camac_read16();
  return(0);
}

